'------------------------------------------------------------------------------
' <autogenerated>
'     This code was generated by Measurement Studio.
'     Runtime Version: 1.1.4322.2032
'
'     Changes to this file may cause incorrect behavior and will be lost if 
'     the code is regenerated.
' </autogenerated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace InstrumentDriverInterop.Ivi
    Public Class niRFSG
        Inherits Object
        Implements System.IDisposable

        Private _handle As System.IntPtr

        Private _disposed As Boolean = True

        '''<summary>
        '''Initializes the NI-RFSG device.
        '''
        '''niRFSG_init performs the following initialization actions:
        '''
        '''- Creates a new instrument driver session. 
        '''- Opens a session to the device you specify for the resourceName
        '''  parameter. 
        '''- If the reset parameter is set to VI_TRUE, niRFSG_init 
        '''  resets  the device to a known state. 
        '''- Returns a ViSession handle that you use to identify the
        '''  NI-RFSG device in all subsequent NI-RFSG function calls.
        '''
        '''NOTE: Before initializing the NI 567X, an NI 54XX AWG module must be associated with the NI 5610 upconverter module in MAX. After association, niRFSG_init initializes both modules. To change the AWG association, modify the NI 5610 Properties page in MAX, or use the niRFSG_InitWithOptions function to override the association in MAX. Refer to the Getting Started Guide for your NI-RFSG device, installed at Start;Programs;National Instruments;NI-RFSG;Documentation for information on MAX association.
        '''
        '''</summary>
        '''<param name="Resource_Name">
        '''Resource Name specifies the resource name of the device to initialize. 
        ''' 
        '''Examples 
        '''-----------------------------------------------------------
        '''myDAQmxDevice       NI-DAQmx device, device name = 
        '''                    "myDAQmxDevice"
        '''myLogicalName       IVI logical name or virtual instrument, 
        '''                    name = "myLogicalName" 
        '''
        '''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 1. Typical default names for NI-DAQmx devices in MAX are Dev 2 or PXI Slot 2. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
        '''
        '''You can also pass in the name of an IVI logical name configured with the IVI Configuration utility. For additional information, refer to the IVI Drivers topic of the MAX Help. 
        '''
        '''CAUTION: NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use an IVI logical name, make sure the name is identical to the name shown in the IVI Configuration Utility.
        '''
        '''Default Value: None
        '''
        '''
        '''</param>
        '''<param name="ID_Query">
        '''Specify whether you want NI-RFSG to perform an ID query.  
        '''
        '''</param>
        '''<param name="Reset">
        '''Specify whether you want the to reset the NI-RFSG device during the initialization procedure.
        '''
        '''Defined Values:
        '''VI_TRUE  (1) - Reset device.
        '''VI_FALSE (0) - Do not reset device. (default)
        '''
        '''</param>
        '''<param name="Instrument_Handle">
        '''Returns a ViSession handle that you use to identify the NI-RFSG device in all subsequent NI-RFSG function calls.
        '''
        '''Notes:
        '''
        '''(1) This function creates a new session each time you invoke it for a different device.
        '''
        '''(2) You cannot create concurrent sessions to the same physical NI-RFSG device.  A better approach is to use the same IVI session in multiple execution threads.  You can use niRFSG_LockSession and niRFSG_UnlockSession to protect sections of code that require exclusive access to a resource.
        '''
        '''
        '''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset As Boolean)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset), Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''<summary>
        '''Initializes the NI-RFSG device (the AWG and upconverter).  niRFSG_InitWithOptions has the capability of receiving the AWG resource name through the option string.
        '''
        '''niRFSG_InitWithOptions performs the following initialization actions:
        '''
        '''- Creates a new IVI instrument driver session.
        '''
        '''- Opens a session to the specified device using the interface and address you specify for the resourceName parameter.
        '''
        '''- If the reset parameter is set to VI_TRUE, niRFSG_InitWithOptions resets all attributes to their default values.
        '''
        '''- Returns a ViSession handle that you use to identify the NI-RFSG device in all subsequent NI-RFSG function calls.
        '''
        '''- Sends attribute values specified in the option string parameter to NI-RFSG.
        '''
        '''</summary>
        '''<param name="Resource_Name">
        '''Resource Name specifies the resource name of the device to initialize.  
        '''
        '''Examples 
        '''-----------------------------------------------------------
        '''myDAQmxDevice       NI-DAQmx device, device name = 
        '''                    "myDAQmxDevice"
        '''myLogicalName       IVI logical name or virtual instrument, 
        '''                    name = "myLogicalName"
        '''
        '''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 1. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
        '''
        '''You can also pass in the name of an IVI logical name configured with the IVI Configuration utility. For additional information, refer to the IVI Drivers topic of the MAX Help. 
        '''
        '''CAUTION: NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use an IVI logical name, make sure the name is identical to the name shown in the IVI Configuration Utility.
        '''
        '''
        '''Default Value:  None
        '''
        '''
        '''</param>
        '''<param name="ID_Query">
        '''Specify whether you want NI-RFSG to perform an ID query.
        '''
        '''</param>
        '''<param name="Reset">
        '''Specify whether you want the to reset the NI-RFSG device during the initialization procedure.
        '''
        '''Defined Values:
        '''VI_TRUE  (1) - Reset device.
        '''VI_FALSE (0) - Do not reset device. (default)
        '''</param>
        '''<param name="Option_String">
        '''Use this parameter to set the initial value of certain attributes for the session.  The following table lists the attributes and the name you pass in this parameter to identify the attribute.
        '''
        '''Name              Attribute   
        '''--------------------------------------------
        '''RangeCheck        NIRFSG_ATTR_RANGE_CHECK
        '''QueryInstrStatus  NIRFSG_ATTR_QUERY_INSTRUMENT_STATUS   
        '''Cache             NIRFSG_ATTR_CACHE   
        '''RecordCoercions   NIRFSG_ATTR_RECORD_COERCIONS
        '''DriverSetup       NIRFSG_ATTR_DRIVER_SETUP
        '''
        '''The format of this string is, "AttributeName=Value" where AttributeName is the name of the attribute and Value is the value to which the attribute will be set.  To set multiple attributes, separate their assignments with a comma.  
        '''
        '''Example Option String:
        '''"RangeCheck=1,QueryInstrStatus=0,Cache=1,DriverSetup=AWG:pxi1slot4"
        '''
        '''
        '''
        '''</param>
        '''<param name="Instrument_Handle">
        '''Returns a ViSession handle that you use to identify the NI-RFSG device in all subsequent NI-RFSG function calls.
        '''
        '''Notes:
        '''
        '''(1) This function creates a new session each time you invoke it for a different device.
        '''
        '''(2) You cannot create concurrent sessions to the same physical NI-RFSG device.  A better approach is to use the same IVI session in multiple execution threads.  You can use niRFSG_LockSession and niRFSG_UnlockSession to protect sections of code that require exclusive access to a resource.
        '''
        '''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset As Boolean, ByVal Option_String As String)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset), Option_String, Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''<summary>
        '''Configures the frequency and power level of the RF output signal. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ConfigureRF.
        '''
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Frequency">
        '''Specifies the frequency of the generated RF signal. For arbitrary waveform generation, this parameter specifies the center frequency of the signal. The units are expressed in Hertz.
        '''
        '''NI-RFSG sets NIRFSG_ATTR_FREQUENCY to this value. Refer to NIRFSG_ATTR_FREQUENCY for valid values.
        '''
        '''</param>
        '''<param name="Power_Level">
        '''Specifies the power level of the generated RF signal. If an arbitrary waveform is being generated, this parameter specifies the average power of the signal. The units are expressed in dBm.
        '''
        '''NI-RFSG sets NIRFSG_ATTR_POWER_LEVEL to this value. Refer to NIRFSG_ATTR_POWER_LEVEL for valid values.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureRF(ByVal Frequency As Double, ByVal Power_Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureRF(Me._handle, Frequency, Power_Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the NI-RFSG device to generate a CW sine tone, apply IQ (vector) modulation to the RF output signal, or play arbitrary waveforms according to scripts.
        '''
        '''The NI-RFSG device must be in the Configuration or Committed state before calling this function.
        '''
        '''
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Generation_Mode">
        '''Specifies the mode used by NI-RFSG for generating an RF output signal. NI-RFSG sets the NIRFSG_ATTR_GENERATION_MODE attribute to this value.
        '''
        '''After initializing the RF signal generator, or calling niRFSG_reset or niRFSG_ResetDevice, this parameter is set to CW. 
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureGenerationMode(ByVal Generation_Mode As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureGenerationMode(Me._handle, Generation_Mode)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Writes an arbitrary waveform to the NI-RFSG device. This function inputs the I and Q vectors of a complex baseband signal. The NI-RFSG device must be in the Configuration state before calling niRFSG_WriteArbWaveform.
        '''
        '''NOTE:  To use real-value signals, feed the signal as the iData and an array of zeros of the same size as the qData. You can also feed the signal as the iData and pass VI_NULL as the qData. 
        '''
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Name">
        '''Specifies the name used to store the waveform. 
        '''
        '''Default Value: "" (empty string)
        '''</param>
        '''<param name="Number_Of_Samples">
        '''The number of samples in both the iData and qData arrays. The iData and qData arrays must have the same length. If the waveform quantum (refer to NIRFSG_ATTR_ARB_WAVEFORM_QUANTUM) is q, then the number of samples should be a multiple of q. The specified number of samples cannot be 0.
        '''</param>
        '''<param name="IData">
        '''NI-RFSG uses the values of this array as the I part of the complex baseband signal. 
        '''</param>
        '''<param name="QData">
        '''NI-RFSG uses the values of this array as the Q part of the complex baseband signal.
        '''</param>
        '''<param name="More_Data_Pending">
        '''Set this value to VI_TRUE to allow data to be appended to the waveform later. Splitting the waveform into multiple data blocks can reduce the memory requirements of the write operation. You can append data to a previously written waveform by using the same waveform name. Set this value to VI_FALSE to indicate that the waveform has no more data.
        '''
        '''Defined Values:
        '''VI_TRUE - Indicates more data is coming from the waveform.
        '''VI_FALSE - Indicates the waveform has no more data.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function WriteArbWaveform(ByVal Name As String, ByVal Number_Of_Samples As Integer, ByVal IData() As Double, ByVal QData() As Double, ByVal More_Data_Pending As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteArbWaveform(Me._handle, Name, Number_Of_Samples, IData, QData, System.Convert.ToUInt16(More_Data_Pending))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Specifies the waveform that is generated upon a call to the niRFSG_Initiate when the Generation_Mode parameter of the niRFSG_ConfigureGenerationMode is set to NIRFSG_VAL_ARB_WAVEFORM. You must specify a waveform name if you have written multiple waveforms. The NI-RFSG device must be in the Configuration or Committed state before calling this VI. 
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Name">
        '''Specifies the name of the stored waveform to generate. NI-RFSG sets NIRFSG_ATTR_ARB_SELECTED_WAVEFORM to this value.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function SelectArbWaveform(ByVal Name As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.SelectArbWaveform(Me._handle, Name)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Deletes a waveform from the pool of waveforms currently defined. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ClearArbWaveform.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Name">
        '''Name of the stored waveform to delete.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ClearArbWaveform(ByVal Name As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ClearArbWaveform(Me._handle, Name)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Deletes all waveforms from the pool of waveforms currently defined. Deletes all scripts from the pool of scripts currently defined. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ClearAllArbWaveforms.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ClearAllArbWaveforms() As Integer
            Dim pInvokeResult As Integer = PInvoke.ClearAllArbWaveforms(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the signal bandwidth of the arbitrary waveform. The NI-RFSG device must be in the Configuration or Committed state before calling this function.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Signal_Bandwidth">
        '''Specifies the signal bandwidth used by NI-RFSG for generating an RF output signal. NI-RFSG sets the NIRFSG_ATTR_SIGNAL_BANDWIDTH  attribute to this value. 
        '''
        '''Default Value: 100 Hz
        '''
        '''Defined Values:
        '''0 Hz to 20 MHz
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureSignalBandwidth(ByVal Signal_Bandwidth As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSignalBandwidth(Me._handle, Signal_Bandwidth)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the start trigger for software triggering.  The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ConfigureSoftwareStartTrigger.
        '''
        '''Refer to niRFSG_SendSoftwareEdgeTrigger for more information on using the software trigger.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureSoftwareStartTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareStartTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the start trigger for digital edge triggering. Signal output begins when a start trigger is recieved. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ConfigureDigitalEdgeStartTrigger.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Source">
        '''The source terminal for the digital edge start trigger. NI-RFSG sets NIRFSG_ATTR_DIGITAL_EDGE_START_TRIGGER_SOURCE to this value. Refer to NIRFSG_ATTR_DIGITAL_EDGE_START_TRIGGER_SOURCE for possible values.
        '''
        '''Default Value: "" (empty string)
        '''
        '''</param>
        '''<param name="Edge">
        '''Specifies the active edge for the start trigger. NI-RFSG sets NIRFSG_ATTR_DIGITAL_EDGE_START_TRIGGER_EDGE to this value. Refer to NIRFSG_ATTR_DIGITAL_EDGE_START_TRIGGER_EDGE for possible values.
        '''
        '''NOTE: Currently NIRFSG_VAL_FALLING_EDGE is unsupported.
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureDigitalEdgeStartTrigger(ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeStartTrigger(Me._handle, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the device to not wait for a start trigger after niRFSG_Initiate is called. Calling niRFSG_DisableStartTrigger is only necessary if the start trigger has been previously configured and now needs to be disabled.
        '''
        '''The NI-RFSG device must be in the Configuration state before calling niRFSG_DisableStartTrigger.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function DisableStartTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableStartTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the script trigger for software triggering.  The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ConfigureSoftwareStartTrigger. Refer to niRFSG_SendSoftwareEdgeTrigger for more information on using the software trigger.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Trigger_Identifier">
        '''This parameter identifies which of the four available script triggers is disabled.
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureSoftwareScriptTrigger(ByVal Trigger_Identifier As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareScriptTrigger(Me._handle, Trigger_Identifier)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the specified script trigger for digital edge triggering.
        '''
        '''The NI-RFSG device must be in the Configuration or Committed state before calling this function.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Trigger_Identifier">
        '''This parameter identifies which of the four available script triggers is disabled.
        '''</param>
        '''<param name="Source">
        '''The source terminal for the digital edge script trigger. NI-RFSG sets NIRFSG_ATTR_DIGITAL_EDGE_SCRIPT_TRIGGER_SOURCE to this value. Refer to NIRFSG_ATTR_DIGITAL_EDGE_SCRIPT_TRIGGER_SOURCE for possible values.
        '''
        '''Default Value: "" (empty string)
        '''
        '''</param>
        '''<param name="Edge">
        '''Specifies the active edge for the digital edge script trigger. NI-RFSG sets NIRFSG_ATTR_DIGITAL_EDGE_SCRIPT_TRIGGER_EDGE to this value. Refer to NIRFSG_ATTR_DIGITAL_EDGE_SCRIPT_TRIGGER_EDGE for possible values.
        '''
        '''NOTE: Currently NIRFSG_VAL_FALLING_EDGE is unsupported.
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureDigitalEdgeScriptTrigger(ByVal Trigger_Identifier As String, ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeScriptTrigger(Me._handle, Trigger_Identifier, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the device to not wait for the specified script trigger. Calling niRFSG_DisableScriptTrigger is only necessary if the script trigger has been previously configured and now needs to be disabled. The NI-RFSG device must be in the Configuration state before calling this function.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Trigger_Identifier">
        '''This parameter identifies which of the four available script triggers is disabled.
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function DisableScriptTrigger(ByVal Trigger_Identifier As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableScriptTrigger(Me._handle, Trigger_Identifier)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Use niRFSG_SendSoftwareEdgeTrigger to force a particular trigger to occur. The specified trigger is generated regardless of whether the trigger has been configured as a software trigger.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Trigger">
        '''Specifies the trigger to assert. NI-RFSG can assert a start trigger or a script trigger.
        '''
        '''Default Value: NIRFSG_VAL_START_TRIGGER
        '''
        '''</param>
        '''<param name="Trigger_Identifier">
        '''If the script trigger is selected, then this parameter identifies which of the four available script triggers is sent.
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function SendSoftwareEdgeTrigger(ByVal Trigger As Integer, ByVal Trigger_Identifier As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.SendSoftwareEdgeTrigger(Me._handle, Trigger, Trigger_Identifier)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Use this function to route signals (triggers and events) to the output terminal you specify. Refer to your device documentation for valid signal destinations. The NI-RFSG device must be in the Configuration or Committed state before calling this function.
        '''
        '''If you export a signal with this function and commit the session, the signal is routed to the output terminal you specify. If you then reconfigure the signal to have a different output terminal, the previous output terminal is tristated when the session is next committed. If you change the output terminal to NIRFSG_VAL_DO_NOT_EXPORT_STR or an empty string when you commit the operation, the previous output terminal is tristated.
        '''
        '''Any signals exported within a session persist after the session closes to prevent signal glitching between sessions. If you wish to have the terminal that the signal was exported to tristated when the session closes, change the output terminal for the exported signal to NIRFSG_VAL_DO_NOT_EXPORT_STR and commit the session again before closing it.
        '''
        '''You can also tristate all PFI lines by setting the reset parameter in niRFSG_Initialize or niRFSG_reset.
        '''
        '''
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Signal">
        '''Signal (trigger or event) to export.
        '''
        '''Defined Values:
        '''
        '''-   NIRFSG_VAL_START_TRIGGER
        '''-   NIRFSG_VAL_SCRIPT_TRIGGER (requires Signal Identifier to describe a particular Script Trigger)
        '''-   NIRFSG_VAL_MARKER_EVENT (requires Signal Identifier to describe a particular Marker)
        '''
        '''
        '''</param>
        '''<param name="Signal_Identifier">
        '''Describes the signal being exported.
        '''
        '''Defined Values:
        '''
        ''' - "ScriptTrigger0"
        ''' - "ScriptTrigger1"
        ''' - "ScriptTrigger2"
        ''' - "ScriptTrigger3"
        ''' - "Marker0"
        ''' - "Marker1"
        ''' - "Marker2"
        ''' - "Marker3"
        ''' - "" (empty String) or VI_NULL
        '''
        '''</param>
        '''<param name="Output_Terminal">
        '''Output terminal where the signal is exported. You can choose not to export any signal.
        '''
        '''Defined Values:
        '''
        '''- NIRFSG_VAL_PFI0_STR 
        '''- NIRFSG_VAL_PFI1_STR
        '''- NIRFSG_VAL_PFI4_STR
        '''- NIRFSG_VAL_PFI5_STR
        '''- NIRFSG_VAL_PXI_TRIG0_STR - NIRFSG_VAL_PXI_TRIG7_STR : the PXI trigger backplane
        '''- "" (empty string) or VI_NULL - the signal is not exported
        '''
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ExportSignal(ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ExportSignal(Me._handle, Signal, Signal_Identifier, Output_Terminal)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Configures the NI-RFSG device reference clock. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ConfigureRefClock.
        '''
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Ref_Clock_Source">
        '''Specifies source of reference clock signal.Only certain combinations of clockSource and PXI Chassis Clock 10 are valid, as shown in the table below. Refer to NIRFSG_ATTR_REF_CLOCK_SOURCE for possible values.
        '''
        '''Default Value: NIRFSG_VAL_ON_BOARD_CLOCK_STR
        '''
        '''Valid Timing Configurations:
        '''
        '''Ref Clock Setting        Valid PXI Chassis Clk10 Setting
        '''-----------------------------------------------------
        '''OnBoardClock             None, OnBoardClock
        '''RefIn                    None, RefIn
        '''PXI_CLK_10               None, RefIn
        '''
        '''NI-RFSG sets NIRFSG_ATTR_REF_CLOCK_SOURCE to this value. 
        '''
        '''Refer to Timing Configurations for more information on valid timing configurations.
        '''</param>
        '''<param name="Ref_Clock_Rate">
        '''Specifies the reference clock rate, expressed in Hertz. NI-RFSG sets NIRFSG_ATTR_REF_CLOCK_RATE to this value.
        '''
        '''Default Value: 10E6 (10 MHz, only supported value)
        '''
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureRefClock(ByVal Ref_Clock_Source As String, ByVal Ref_Clock_Rate As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureRefClock(Me._handle, Ref_Clock_Source, Ref_Clock_Rate)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Specifies the signal to drive the 10 MHz reference clock to the PXI backplane. This option can only be configured when the PXI-5610 is in PXI Slot 2. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_ConfigurePXIChassisClk10.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="PXI_Clk_10_Source">
        '''Specifies the source for the signal that drives the 10 MHz reference clock on the PXI backplane. NI-RFSG sets NIRFSG_ATTR_PXI_CHASSIS_CLK10_SOURCE to this value.
        '''
        '''Default Value: NIRFSG_VAL_NONE
        '''
        '''Valid Timing Configurations:
        '''
        '''PXI Chassis Clk10 Setting      Valid Ref Clock Setting  
        '''------------------------------------------------------
        '''None, OnBoardClock             OnBoardClock 
        '''None, RefIn                    RefIn (external)
        '''None, RefIn                    PXI_CLK_10 
        '''
        '''
        '''Refer to Timing Configurations for more information on valid timing configurations.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigurePXIChassisClk10(ByVal PXI_Clk_10_Source As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePXIChassisClk10(Me._handle, PXI_Clk_10_Source)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Specifies a string containing a script that controls waveform generation in script mode. The NI-RFSG device must be in the Configuration or Committed state before calling this function.
        '''
        '''If this function is called repeatedly, previously written scripts with unique names remain loaded. Previously written scripts with identical names to those being written are replaced.
        '''
        '''If there are multiple scripts loaded when niRFSG_Initiate is called, then one of the scripts must be designated as the script to generate by setting NIRFSG_ATTR_SCRIPT_TO_GENERATE to the desired script name.  If there is only one script in memory, then there is no need to designate the script to generate. 
        '''
        '''An error is returned at commit time if the script uses incorrect syntax.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Script">
        '''Specifies a string containing a syntactically correct script. NI-RFSG supports multiple scripts that may be selected by name with the Selected Script property. Refer to Scripting Instruction for more information on using scripts. 
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function WriteScript(ByVal Script As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteScript(Me._handle, Script)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Enables or disables signal output. This function can be called in any software state, and it does not change the current software state (the NI-RFSG device remains in the Configuration state, Committed state, or Signal Generation state). Setting enabled to VI_FALSE while in the Signal Generation state stops signal output although generation continues internally.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Output_Enabled">
        '''NI-RFSG sets NIRFSG_ATTR_OUTPUT_ENABLED to this value. 
        '''
        '''Default value:  VI_TRUE
        '''
        '''Defined Values:
        '''VI_TRUE - enables signal output
        '''VI_FALSE - disables signal output
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ConfigureOutputEnabled(ByVal Output_Enabled As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureOutputEnabled(Me._handle, System.Convert.ToUInt16(Output_Enabled))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Initiates signal generation, causing the NI-RFSG device to leave the Configuration or Committed state and enter the Generation state. If the settings have not been committed to the device before you use this function, they are committed with this function. The operation returns when the RF output signal is settled. 
        '''
        '''To return to the Configuration state, call niRFSG_Abort.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions. The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function Initiate() As Integer
            Dim pInvokeResult As Integer = PInvoke.Initiate(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Checks the status of the generation. 
        '''
        '''Use niRFSG_CheckGenerationStatus to check for any errors that might occur during the signal generation or to check whether the device is done generating. If generation is taking place and no errors have occurred, this function returns a successful status.
        '''
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Is_Done">
        '''Returns true if waveform generation is done.
        '''
        '''TODO: Need this documentation looked over!
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function CheckGenerationStatus(ByRef Is_Done As Boolean) As Integer
            Dim Is_DoneAsUShort As System.UInt16
            Dim pInvokeResult As Integer = PInvoke.CheckGenerationStatus(Me._handle, Is_DoneAsUShort)
            Is_Done = System.Convert.ToBoolean(Is_DoneAsUShort)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Aborts a previously initiated signal generation.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function Abort() As Integer
            Dim pInvokeResult As Integer = PInvoke.Abort(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Asserts the configured hardware parameters. Calling niRFSG_Commit moves the NI-RFSG device out of the Configuration state and into the Committed state. 
        '''
        '''Once you call niRFSG_Commit, changing any attribute reverts the NI-RFSG device to the Configuration state.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function Commit() As Integer
            Dim pInvokeResult As Integer = PInvoke.Commit(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Corrects any drift in RF signal generator output power due to environmental temperature variation. To maintain specified power accuracy over extended periods, the environmental temperature must not vary more than approximately 1 0C for every 0.1 dB of accuracy constraint. In such cases, call niRFSG_PerformThermalCorrection as needed to maintain specified power accuracy.
        '''
        '''The NI-RFSG device must be in the Generation state before calling this function.
        '''
        '''Reading this attribute causes transient noise in the RF output signal. Refer to the thermal management section for more information.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function PerformThermalCorrection() As Integer
            Dim pInvokeResult As Integer = PInvoke.PerformThermalCorrection(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Waits (up to the time specified in the maxTimeMilliseconds parameter) until the RF output signal is settled. Call this function after calling niRFSG_Commit for applications in which it is important to start signal generation immediately upon calling niRFSG_Initiate. 
        '''
        '''
        '''Call niRFSG_WaitUntilSettled after niRFSG_Commit and before niRFSG_Initiate. 
        '''
        '''viCheckErr ( niRFSG_Commit(vi) );
        '''viCheckErr ( niRFSG_WaitUntilSettled(vi, 10000) );
        '''viCheckErr ( niRFSG_Initiate(vi) );
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Max_Time_Milliseconds">
        '''Defines the maximum time the function waits for the output to be settled. If the maximum time is exceeded, this function returns the Max Time Exceeded error. 
        '''
        '''If a -1 is given as maxTimeMilliseconds, NI-RFSG waits indefinitely until it is settled. The units are expressed in milliseconds.
        '''
        '''Default Value: 10000
        '''
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function WaitUntilSettled(ByVal Max_Time_Milliseconds As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.WaitUntilSettled(Me._handle, Max_Time_Milliseconds)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Resets all attributes to their default values and moves the NI-RFSG device to the Configuration state. niRFSG_reset aborts the generation, clears all routes, and resets session attributes to the initial values. During a reset, routes of signals between this and other devices are released, regardless of which device created the route. For example, a trigger signal exported to a PXI trigger line that is used by another device is no longer exported.
        '''
        '''In general, calling niRFSG_reset instead of niRFSG_ResetDevice is recommended. niRFSG_reset executes faster than niRFSG_ResetDevice.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function reset() As Integer
            Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Performs a hard reset on the device. Generation is stopped, all routes are released, external bi-directional terminals are tri-stated, FPGAs are reset, hardware is configured to its default state, and all session attributes are reset to their default states. During a reset, routes of signals between this and other devices are released, regardless of which device created the route. For example, a trigger signal exported to a PXI trigger line that is used by another device is no longer exported.
        '''
        '''In general, calling niRFSG_reset instead of niRFSG_ResetDevice is recommended. niRFSG_reset executes faster than niRFSG_ResetDevice. Allow 15 seconds after calling this function for the NI-RFSG device to become fully functional again.
        '''
        '''You must call niRFSG_ResetDevice if the NI-RFSG device has shut down because of high temperature conditions.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function ResetDevice() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Performs a self-test on the NI-RFSG device and returns the test results. niRFSG_self_test performs a simple series of tests ensuring the NI-RFSG device is powered up and responding.  These tests include an FPGA access test, RAM test, FPGA download test, and tests to ensure successful communication and locking of various oscillators on the device.
        '''
        '''niRFSG_self_test does not affect external I/O connections or connections between devices.  Complete functional testing and calibration are not performed by this function. The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_self_test.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Self_Test_Result">
        '''This parameter contains the value returned from the NI-RFSG device self test.  Zero means success.  For any other code, refer to NI-RFSG Error and Completion Codes.
        '''
        '''Self-Test Code    Description
        '''---------------------------------------
        '''   0              Passed self test
        '''   1              Self test failed
        '''</param>
        '''<param name="Self_Test_Message">
        '''Returns the self-test response string from the NI-RFSG device. Refer to the NI RF Signal Generator Help for an explanation of the string's contents.
        '''
        '''You must pass a ViChar array with at least 256 bytes.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Performs an internal (self-) calibration on the device. If the calibration is successful, new calibration data and constants are stored in the onboard nonvolatile memory of the module.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function SelfCal() As Integer
            Dim pInvokeResult As Integer = PInvoke.SelfCal(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Returns the revision numbers of the NI-RFSG driver.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Instrument_Driver_Revision">
        '''Returns the value of NIRFSG_ATTR_SPECIFIC_DRIVER_REVISION in the form of a string.
        '''
        '''You must pass a ViChar array with at least 256 bytes.
        '''</param>
        '''<param name="Firmware_Revision">
        '''Returns the value of NIRFSG_ATTR_INSTRUMENT_FIRMWARE_REVISION in the form of a string.
        '''
        '''You must pass a ViChar array with at least 256 bytes.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''<summary>
        '''Queries and returns the waveform capabilities of the NI-RFSG device. These capabilities are related to the current device configuration.
        '''
        '''Use niRFSG_QueryArbWaveformCapabilities to query the attributes of the NI-RFSG device such as the maximum and minimum waveform size that you can write.
        '''
        '''The NI-RFSG device must be in the Configuration or Committed state before calling niRFSG_QueryArbWaveformCapabilities.
        '''</summary>
        '''<param name="Instrument_Handle">
        '''The ViSession handle that you obtain from niRFSG_init or niRFSG_InitWithOptions.  The handle identifies a particular instrument session.
        '''
        '''Default Value:  None
        '''</param>
        '''<param name="Max_Number_Waveforms">
        '''Returns the value of NIRFSG_ATTR_ARB_MAX_NUMBER_WAVEFORMS. This value is the maximum number of waveforms you can write.
        '''</param>
        '''<param name="Waveform_Quantum">
        '''Returns the value of NIRFSG_ATTR_ARB_WAVEFORM_QUANTUM. If the waveform quantum is q, then the size of the waveform that you write should be a multiple of q. The units are expressed in samples.
        '''</param>
        '''<param name="Min_Waveform_Size">
        '''Returns the value of NIRFSG_ATTR_ARB_WAVEFORM_SIZE_MIN. The number of samples of the waveform that you write must be greater than or equal to this value.
        '''</param>
        '''<param name="Max_Waveform_Size">
        '''Returns the value of NIRFSG_ATTR_ARB_WAVEFORM_SIZE_MAX. The number of samples of the waveform that you write must be less than or equal to this value.
        '''</param>
        '''<returns>
        '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
        '''
        '''To obtain a text description of the status code, call the niRFSG_error_message function.  To obtain additional information about the error condition, call the niRFSG_GetError function.  To clear the error information from the driver, call the niRFSG_ClearError function.
        '''          
        '''The general meaning of the status code is as follows:
        '''
        '''Value                  Meaning
        '''-------------------------------
        '''0                      Success
        '''Positive Values        Warnings
        '''Negative Values        Errors
        '''
        '''</returns>
        Public Function QueryArbWaveformCapabilities(ByRef Max_Number_Waveforms As Integer, ByRef Waveform_Quantum As Integer, ByRef Min_Waveform_Size As Integer, ByRef Max_Waveform_Size As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.QueryArbWaveformCapabilities(Me._handle, Max_Number_Waveforms, Waveform_Quantum, Min_Waveform_Size, Max_Waveform_Size)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
            Me.Dispose(True)
            System.GC.SuppressFinalize(Me)
        End Sub

        Private Overloads Sub Dispose(ByVal disposing As Boolean)
            If (Me._disposed = False) Then
                PInvoke.close(Me._handle)
                Me._handle = System.IntPtr.Zero
            End If
            Me._disposed = True
        End Sub

        Protected Overrides Sub Finalize()
            Me.Dispose(False)
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As niRFSGProperties, ByVal val As Integer)
            Me.SetInt32(propertyId, "", val)
        End Sub

        Public Overloads Function GetInt32(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
            Dim val As Integer
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetInt32(ByVal propertyId As niRFSGProperties) As Integer
            Return Me.GetInt32(propertyId, "")
        End Function

        Public Overloads Sub SetDouble(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetDouble(ByVal propertyId As niRFSGProperties, ByVal val As Double)
            Me.SetDouble(propertyId, "", val)
        End Sub

        Public Overloads Function GetDouble(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String) As Double
            Dim val As Double
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetDouble(ByVal propertyId As niRFSGProperties) As Double
            Return Me.GetDouble(propertyId, "")
        End Function

        Public Overloads Sub SetBoolean(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), System.Convert.ToUInt16(val)))
        End Sub

        Public Overloads Sub SetBoolean(ByVal propertyId As niRFSGProperties, ByVal val As Boolean)
            Me.SetBoolean(propertyId, "", val)
        End Sub

        Public Overloads Function GetBoolean(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
            Dim val As System.UInt16
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return System.Convert.ToBoolean(val)
        End Function

        Public Overloads Function GetBoolean(ByVal propertyId As niRFSGProperties) As Boolean
            Return Me.GetBoolean(propertyId, "")
        End Function

        Public Overloads Sub SetString(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetString(ByVal propertyId As niRFSGProperties, ByVal val As String)
            Me.SetString(propertyId, "", val)
        End Sub

        Public Overloads Function GetString(ByVal propertyId As niRFSGProperties, ByVal repeatedCapabilityOrChannel As String) As String
            Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
            Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), 512, newVal)
            If (size < 0) Then
                PInvoke.ThrowError(Me._handle, size)
            Else
                If (size > 0) Then
                    newVal.Capacity = size
                    PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), size, newVal))
                End If
            End If
            Return newVal.ToString
        End Function

        Public Overloads Function GetString(ByVal propertyId As niRFSGProperties) As String
            Return Me.GetString(propertyId, "")
        End Function

        Private Class PInvoke

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_init", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function init(ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset As System.UInt16, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function InitWithOptions(ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset As System.UInt16, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureRF", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureRF(ByVal Instrument_Handle As System.IntPtr, ByVal Frequency As Double, ByVal Power_Level As Double) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureGenerationMode", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureGenerationMode(ByVal Instrument_Handle As System.IntPtr, ByVal Generation_Mode As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_WriteArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function WriteArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Name As String, ByVal Number_Of_Samples As Integer, ByVal IData As Double(), ByVal QData As Double(), ByVal More_Data_Pending As System.UInt16) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SelectArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SelectArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Name As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ClearArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ClearArbWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Name As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ClearAllArbWaveforms", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ClearAllArbWaveforms(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureSignalBandwidth", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureSignalBandwidth(ByVal Instrument_Handle As System.IntPtr, ByVal Signal_Bandwidth As Double) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureSoftwareStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureSoftwareStartTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureDigitalEdgeStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureDigitalEdgeStartTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_DisableStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function DisableStartTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureSoftwareScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureSoftwareScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Identifier As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureDigitalEdgeScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureDigitalEdgeScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Identifier As String, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_DisableScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function DisableScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Identifier As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SendSoftwareEdgeTrigger", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SendSoftwareEdgeTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger As Integer, ByVal Trigger_Identifier As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ExportSignal", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ExportSignal(ByVal Instrument_Handle As System.IntPtr, ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureRefClock", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureRefClock(ByVal Instrument_Handle As System.IntPtr, ByVal Ref_Clock_Source As String, ByVal Ref_Clock_Rate As Double) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigurePXIChassisClk10", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigurePXIChassisClk10(ByVal Instrument_Handle As System.IntPtr, ByVal PXI_Clk_10_Source As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_WriteScript", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function WriteScript(ByVal Instrument_Handle As System.IntPtr, ByVal Script As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ConfigureOutputEnabled", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ConfigureOutputEnabled(ByVal Instrument_Handle As System.IntPtr, ByVal Output_Enabled As System.UInt16) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_Initiate", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function Initiate(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_CheckGenerationStatus", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function CheckGenerationStatus(ByVal Instrument_Handle As System.IntPtr, ByRef Is_Done As System.UInt16) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_Abort", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function Abort(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_Commit", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function Commit(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_PerformThermalCorrection", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function PerformThermalCorrection(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_WaitUntilSettled", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function WaitUntilSettled(ByVal Instrument_Handle As System.IntPtr, ByVal Max_Time_Milliseconds As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_reset", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function reset(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_ResetDevice", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function ResetDevice(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_self_test", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function self_test(ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SelfCal", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SelfCal(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_revision_query", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function revision_query(ByVal Instrument_Handle As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_QueryArbWaveformCapabilities", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function QueryArbWaveformCapabilities(ByVal Instrument_Handle As System.IntPtr, ByRef Max_Number_Waveforms As Integer, ByRef Waveform_Quantum As Integer, ByRef Min_Waveform_Size As Integer, ByRef Max_Waveform_Size As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_close", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function close(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_error_message", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function error_message(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function GetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function GetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Double) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function GetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Buffer_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function GetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.UInt16) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function GetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.UInt16) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function SetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
            End Function

            <DllImport("niRFSG.dll", EntryPoint:="niRFSG_GetError", CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Function GetError(ByVal Instrument_Handle As System.IntPtr, ByRef errorCode As Integer, ByVal BufferSize As Integer, ByVal Description As System.Text.StringBuilder) As Integer
            End Function

            Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
                If (status < 0) Then
                    PInvoke.ThrowError(handle, status)
                End If
                Return status
            End Function

            Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
                Dim status As Integer
                Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
                Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
                If (size >= 0) Then
                    msg.Capacity = size
                    PInvoke.GetError(handle, status, size, msg)
                End If
                Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
            End Function
        End Class
    End Class

    Public Class niRFSGConstants

        Public Const Enable As Integer = 1

        Public Const Rtsi7Str As String = "RTSI7"

        Public Const NoneStr As String = "None"

        Public Const Rtsi0Str As String = "RTSI0"

        Public Const Pfi1Str As String = "PFI1"

        Public Const PxiTrig3Str As String = "PXI_Trig3"

        Public Const ArbWaveform As Integer = 1001

        Public Const MarkerEvent As Integer = 2

        Public Const Rtsi4Str As String = "RTSI4"

        Public Const RisingEdge As Integer = 0

        Public Const Pfi5Str As String = "PFI5"

        Public Const Low As Integer = 0

        Public Const PxiTrig2Str As String = "PXI_Trig2"

        Public Const RefInStr As String = "RefIn"

        Public Const PxiTrig7Str As String = "PXI_Trig7"

        Public Const Software As Integer = 2

        Public Const PxiTrig6Str As String = "PXI_Trig6"

        Public Const Rtsi1Str As String = "RTSI1"

        Public Const Pfi2Str As String = "PFI2"

        Public Const Pfi4Str As String = "PFI4"

        Public Const Rtsi5Str As String = "RTSI5"

        Public Const Medium As Integer = 1

        Public Const ViTrue As Boolean = 1

        Public Const Pfi3Str As String = "PFI3"

        Public Const DigitalEdge As Integer = 1

        Public Const MarkerEvent3 As String = "marker3"

        Public Const MarkerEvent2 As String = "marker2"

        Public Const MarkerEvent1 As String = "marker1"

        Public Const MarkerEvent0 As String = "marker0"

        Public Const PxiTrig1Str As String = "PXI_Trig1"

        Public Const DoNotExportStr As String = ""

        Public Const Rtsi2Str As String = "RTSI2"

        Public Const [Auto] As Integer = -1

        Public Const Disable As Integer = 0

        Public Const Script As Integer = 1002

        Public Const ScriptTrigger As Integer = 1

        Public Const Cw As Integer = 1000

        Public Const Rtsi6Str As String = "RTSI6"

        Public Const StartTrigger As Integer = 0

        Public Const PxiTrig5Str As String = "PXI_Trig5"

        Public Const None As Integer = 0

        Public Const ScriptTrigger2 As String = "scriptTrigger2"

        Public Const ScriptTrigger3 As String = "scriptTrigger3"

        Public Const ScriptTrigger0 As String = "scriptTrigger0"

        Public Const ScriptTrigger1 As String = "scriptTrigger1"

        Public Const OnBoardClockStr As String = "OnBoardClock"

        Public Const PxiTrig0Str As String = "PXI_Trig0"

        Public Const OnboardClockStr As String = "OnBoardClock"

        Public Const Pfi0Str As String = "PFI0"

        Public Const FallingEdge As Integer = 1

        Public Const PxiClk10Str As String = "PXI_CLK10"

        Public Const High As Integer = 2

        Public Const PxiTrig4Str As String = "PXI_Trig4"

        Public Const PxiStarStr As String = "PXI_STAR"

        Public Const Rtsi3Str As String = "RTSI3"

        Public Const ViFalse As Boolean = 0
    End Class

    Public Enum niRFSGProperties

        '''<summary>
        '''System.Double
        '''</summary>
        Frequency = 1250001

        '''<summary>
        '''System.Double
        '''</summary>
        PowerLevel = 1250002

        '''<summary>
        '''System.Double
        '''</summary>
        PeakEnvelopePower = 1150011

        '''<summary>
        '''System.Boolean
        '''</summary>
        LocalOscillatorOut0Enabled = 1150013

        '''<summary>
        '''System.Boolean
        '''</summary>
        OutputEnabled = 1250004

        '''<summary>
        '''System.Double
        '''</summary>
        FrequencyTolerance = 1150006

        '''<summary>
        '''System.Boolean
        '''</summary>
        AttenuatorHoldEnabled = 1150009

        '''<summary>
        '''System.Double
        '''</summary>
        AttenuatorHoldMaxPower = 1150010

        '''<summary>
        '''System.Double
        '''</summary>
        DucPreFilterGain = 1150025

        '''<summary>
        '''System.Double
        '''</summary>
        IfCarrierFrequency = 1150015

        '''<summary>
        '''System.Double
        '''</summary>
        IfPower = 1150016

        '''<summary>
        '''System.Double
        '''</summary>
        UpconverterCenterFrequency = 1154098

        '''<summary>
        '''System.Double
        '''</summary>
        UpconverterGain = 1154097

        '''<summary>
        '''System.Double
        '''</summary>
        UpconverterTemperature = 1150017

        '''<summary>
        '''System.Int32
        '''</summary>
        UpconverterLoopBandwidth = 1150027

        '''<summary>
        '''System.Int32
        '''</summary>
        AllowOutOfSpecificationUserSettings = 1150014

        '''<summary>
        '''System.Int32
        '''</summary>
        GenerationMode = 1150018

        '''<summary>
        '''System.Double
        '''</summary>
        SignalBandwidth = 1150007

        '''<summary>
        '''System.String
        '''</summary>
        ArbSelectedWaveform = 1250451

        '''<summary>
        '''System.Int32
        '''</summary>
        ArbMaxNumberWaveforms = 1250454

        '''<summary>
        '''System.Int32
        '''</summary>
        ArbWaveformSizeMin = 1250456

        '''<summary>
        '''System.Int32
        '''</summary>
        ArbWaveformSizeMax = 1250457

        '''<summary>
        '''System.Int32
        '''</summary>
        ArbWaveformQuantum = 1250455

        '''<summary>
        '''System.Int32
        '''</summary>
        DigitalIfEqualizationEnabled = 1150012

        '''<summary>
        '''System.Double
        '''</summary>
        IqRate = 1250452

        '''<summary>
        '''System.Int32
        '''</summary>
        PhaseContinuityEnabled = 1150005

        '''<summary>
        '''System.Boolean
        '''</summary>
        IqSwapEnabled = 1250404

        '''<summary>
        '''System.String
        '''</summary>
        RefClockSource = 1150001

        '''<summary>
        '''System.Double
        '''</summary>
        RefClockRate = 1250322

        '''<summary>
        '''System.String
        '''</summary>
        PxiChassisClk10Source = 1150004

        '''<summary>
        '''System.Int32
        '''</summary>
        StartTriggerType = 1250458

        '''<summary>
        '''System.String
        '''</summary>
        DigitalEdgeStartTriggerSource = 1150002

        '''<summary>
        '''System.Int32
        '''</summary>
        DigitalEdgeStartTriggerEdge = 1250459

        '''<summary>
        '''System.String
        '''</summary>
        ExportedStartTriggerOutputTerminal = 1150003

        '''<summary>
        '''System.Int32
        '''</summary>
        ScriptTriggerType = 1150019

        '''<summary>
        '''System.String
        '''</summary>
        DigitalEdgeScriptTriggerSource = 1150020

        '''<summary>
        '''System.Int32
        '''</summary>
        DigitalEdgeScriptTriggerEdge = 1150021

        '''<summary>
        '''System.String
        '''</summary>
        ExportedScriptTriggerOutputTerminal = 1150022

        '''<summary>
        '''System.String
        '''</summary>
        SelectedScript = 1150023

        '''<summary>
        '''System.String
        '''</summary>
        SerialNumber = 1150026

        '''<summary>
        '''System.Boolean
        '''</summary>
        RangeCheck = 1050002

        '''<summary>
        '''System.Boolean
        '''</summary>
        QueryInstrumentStatus = 1050003

        '''<summary>
        '''System.Boolean
        '''</summary>
        Cache = 1050004

        '''<summary>
        '''System.Boolean
        '''</summary>
        Simulate = 1050005

        '''<summary>
        '''System.Boolean
        '''</summary>
        RecordCoercions = 1050006

        '''<summary>
        '''System.Boolean
        '''</summary>
        InterchangeCheck = 1050021

        '''<summary>
        '''System.String
        '''</summary>
        SpecificDriverDescription = 1050514

        '''<summary>
        '''System.String
        '''</summary>
        SpecificDriverPrefix = 1050302

        '''<summary>
        '''System.String
        '''</summary>
        SpecificDriverVendor = 1050513

        '''<summary>
        '''System.String
        '''</summary>
        SpecificDriverRevision = 1050551

        '''<summary>
        '''System.Int32
        '''</summary>
        SpecificDriverClassSpecMajorVersion = 1050515

        '''<summary>
        '''System.Int32
        '''</summary>
        SpecificDriverClassSpecMinorVersion = 1050516

        '''<summary>
        '''System.String
        '''</summary>
        SupportedInstrumentModels = 1050327

        '''<summary>
        '''System.String
        '''</summary>
        GroupCapabilities = 1050401

        '''<summary>
        '''System.String
        '''</summary>
        InstrumentManufacturer = 1050511

        '''<summary>
        '''System.String
        '''</summary>
        InstrumentModel = 1050512

        '''<summary>
        '''System.String
        '''</summary>
        InstrumentFirmwareRevision = 1050510

        '''<summary>
        '''System.String
        '''</summary>
        LogicalName = 1050305

        '''<summary>
        '''System.String
        '''</summary>
        IoResourceDescriptor = 1050304

        '''<summary>
        '''System.String
        '''</summary>
        DriverSetup = 1050007
    End Enum
End Namespace